import _toConsumableArray from "@babel/runtime/helpers/esm/toConsumableArray";
import _slicedToArray from "@babel/runtime/helpers/esm/slicedToArray";
import React, { useContext } from 'react';
import classNames from 'classnames';
import ConfigProviderContext from '../config-provider/ConfigProviderContext';
var CalendarHeader = function CalendarHeader(props) {
  var _useContext = useContext(ConfigProviderContext),
    prefixCls = _useContext.prefixCls,
    createNamespace = _useContext.createNamespace;
  var _createNamespace = createNamespace('calendar', prefixCls),
    _createNamespace2 = _slicedToArray(_createNamespace, 1),
    bem = _createNamespace2[0];
  var onClickSubtitle = props.onClickSubtitle,
    showTitle = props.showTitle,
    showSubtitle = props.showSubtitle,
    firstDayOfWeek = props.firstDayOfWeek;
  var renderTitle = function renderTitle() {
    var title = props.title;
    return showTitle ? /*#__PURE__*/React.createElement("div", {
      className: classNames(bem('header-title'))
    }, title) : null;
  };
  var renderSubtitle = function renderSubtitle() {
    var title = props.subtitle;
    return showSubtitle ? /*#__PURE__*/React.createElement("div", {
      className: classNames(bem('header-subtitle')),
      onClick: onClickSubtitle
    }, title) : null;
  };
  var renderWeekDays = function renderWeekDays() {
    var weekdays = ['日', '一', '二', '三', '四', '五', '六'];
    var renderWeekDaysArr = [].concat(_toConsumableArray(weekdays.slice(firstDayOfWeek, 7)), _toConsumableArray(weekdays.slice(0, firstDayOfWeek)));
    return /*#__PURE__*/React.createElement("div", {
      className: classNames(bem('weekdays'))
    }, renderWeekDaysArr.map(function (text, index) {
      return /*#__PURE__*/React.createElement("span", {
        key: index,
        className: classNames(bem('weekday'))
      }, text);
    }));
  };
  return /*#__PURE__*/React.createElement("div", {
    className: classNames(bem('header'))
  }, renderTitle(), renderSubtitle(), renderWeekDays());
};
export default CalendarHeader;