import _extends from "@babel/runtime/helpers/esm/extends";
import _slicedToArray from "@babel/runtime/helpers/esm/slicedToArray";
import React, { forwardRef, useContext } from 'react';
import classnames from 'classnames';
import DatePicker from './DatePicker';
import TimePicker from './TimePicker';
import ConfigProviderContext from '../config-provider/ConfigProviderContext';
var DateTimePicker = /*#__PURE__*/forwardRef(function (props, ref) {
  var _useContext = useContext(ConfigProviderContext),
    prefixCls = _useContext.prefixCls,
    createNamespace = _useContext.createNamespace;
  var _createNamespace = createNamespace('datetime-picker', prefixCls),
    _createNamespace2 = _slicedToArray(_createNamespace, 1),
    bem = _createNamespace2[0];
  var isTimePicker = props.type === 'time';
  var Component = isTimePicker ? TimePicker : DatePicker;
  return /*#__PURE__*/React.createElement(Component, _extends({
    ref: ref,
    className: classnames(bem())
  }, props));
});
export default DateTimePicker;
export { DateTimePicker };