import _slicedToArray from "@babel/runtime/helpers/esm/slicedToArray";
import React, { useContext } from 'react';
import classNames from 'classnames';
import { DEFAULT_EVENTS } from './utils';
import ConfigProviderContext from '../config-provider/ConfigProviderContext';
import useEventVisible from './utils/useEventVisible';
var Lazyload = function Lazyload(props) {
  var _useContext = useContext(ConfigProviderContext),
    prefixCls = _useContext.prefixCls,
    createNamespace = _useContext.createNamespace;
  var _createNamespace = createNamespace('lazyload', prefixCls),
    _createNamespace2 = _slicedToArray(_createNamespace, 1),
    bem = _createNamespace2[0];
  var children = props.children,
    loading = props.loading,
    scrollContainer = props.scrollContainer,
    listenEvents = props.listenEvents,
    offset = props.offset,
    debounce = props.debounce,
    throttle = props.throttle,
    height = props.height,
    className = props.className,
    style = props.style;
  var _useEventVisible = useEventVisible({
      listenEvents: listenEvents,
      offset: offset,
      scrollContainer: scrollContainer,
      debounce: debounce,
      throttle: throttle
    }),
    _useEventVisible2 = _slicedToArray(_useEventVisible, 2),
    containerRef = _useEventVisible2[0],
    visible = _useEventVisible2[1];
  return /*#__PURE__*/React.createElement("div", {
    className: classNames(bem(), className),
    style: style,
    ref: containerRef
  }, visible ? children : loading || /*#__PURE__*/React.createElement("div", {
    style: {
      height: height
    },
    className: classNames(bem('placeholder'))
  }));
};
Lazyload.defaultProps = {
  loading: null,
  className: '',
  height: 0,
  listenEvents: DEFAULT_EVENTS,
  scrollContainer: document.body,
  offset: 0,
  debounce: 300,
  throttle: 0
};
export default Lazyload;