import _defineProperty from "@babel/runtime/helpers/esm/defineProperty";
import _objectWithoutProperties from "@babel/runtime/helpers/esm/objectWithoutProperties";
import _slicedToArray from "@babel/runtime/helpers/esm/slicedToArray";
var _excluded = ["style", "type", "height", "width", "image", "errorImage", "eventOptions", "observerOptions", "loading", "className", "onLoaded"];
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
import React, { useContext, createElement, useEffect } from 'react';
import classNames from 'classnames';
import ConfigProviderContext from '../config-provider/ConfigProviderContext';
import useImageVisible from './utils/useImageVisible';
import { DEFAULT_URL } from './utils';
var LazyloadImage = function LazyloadImage(props) {
  var _useContext = useContext(ConfigProviderContext),
    prefixCls = _useContext.prefixCls,
    createNamespace = _useContext.createNamespace;
  var _createNamespace = createNamespace('lazyload-image', prefixCls),
    _createNamespace2 = _slicedToArray(_createNamespace, 1),
    bem = _createNamespace2[0];
  var incomingStyle = props.style,
    type = props.type,
    height = props.height,
    width = props.width,
    image = props.image,
    errorImage = props.errorImage,
    eventOptions = props.eventOptions,
    observerOptions = props.observerOptions,
    loading = props.loading,
    className = props.className,
    onLoaded = props.onLoaded,
    restProps = _objectWithoutProperties(props, _excluded);
  var _useImageVisible = useImageVisible(observerOptions, errorImage),
    _useImageVisible2 = _slicedToArray(_useImageVisible, 2),
    containerRef = _useImageVisible2[0],
    hasLoaded = _useImageVisible2[1];
  useEffect(function () {
    if (hasLoaded) {
      var _props$onLoaded;
      (_props$onLoaded = props.onLoaded) === null || _props$onLoaded === void 0 ? void 0 : _props$onLoaded.call(props);
    }
  }, [hasLoaded]);
  var style = _objectSpread(_objectSpread({}, incomingStyle), {}, {
    height: height,
    width: width
  });
  return /*#__PURE__*/React.createElement(React.Fragment, null, type === 'image' ? /*#__PURE__*/createElement('img', _objectSpread(_objectSpread({}, restProps), {}, {
    ref: containerRef,
    style: style,
    'data-src': image,
    src: loading || DEFAULT_URL,
    className: classNames(bem(), className)
  })) : /*#__PURE__*/createElement('div', _objectSpread(_objectSpread({}, restProps), {}, {
    ref: containerRef,
    style: style,
    'data-src': image,
    className: classNames(bem(), className)
  }), props.children));
};
LazyloadImage.defaultProps = {
  image: '60',
  className: '',
  type: 'image'
};
export default LazyloadImage;