import _slicedToArray from "@babel/runtime/helpers/esm/slicedToArray";
import React, { useContext } from 'react';
import classNames from 'classnames';
import ConfigProviderContext from '../config-provider/ConfigProviderContext';
import useVisible from './utils/useVisible';
var Lazyload = function Lazyload(props) {
  var _useContext = useContext(ConfigProviderContext),
    prefixCls = _useContext.prefixCls,
    createNamespace = _useContext.createNamespace;
  var _createNamespace = createNamespace('lazyload', prefixCls),
    _createNamespace2 = _slicedToArray(_createNamespace, 1),
    bem = _createNamespace2[0];
  var children = props.children,
    forceVisible = props.forceVisible,
    className = props.className,
    height = props.height,
    style = props.style,
    loading = props.loading;
  var _useVisible = useVisible(forceVisible),
    _useVisible2 = _slicedToArray(_useVisible, 2),
    ref = _useVisible2[0],
    hasLoaded = _useVisible2[1];
  return /*#__PURE__*/React.createElement("div", {
    className: classNames(bem(), className),
    style: style,
    ref: ref
  }, hasLoaded ? children : loading || /*#__PURE__*/React.createElement("div", {
    style: {
      height: height
    },
    className: classNames(bem('placeholder'))
  }));
};
Lazyload.defaultProps = {
  loading: null,
  forceVisible: false,
  height: 0,
  className: '',
  style: {}
};
export default Lazyload;