import _slicedToArray from "@babel/runtime/helpers/esm/slicedToArray";
import { useCallback, useState } from 'react';
import { addCssClassName, loadImage, setImage } from '.';
import useIntersectionObserver from './useIntersectionObserver';
var defaultObserverOptions = {
  threshold: [0, 1]
};
var useImageVisible = function useImageVisible() {
  var observerOptions = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : defaultObserverOptions;
  var errorImage = arguments.length > 1 ? arguments[1] : undefined;
  var _useState = useState(false),
    _useState2 = _slicedToArray(_useState, 2),
    isLoaded = _useState2[0],
    setIsLoaded = _useState2[1];
  var handleIntersection = useCallback(function (entries) {
    entries.filter(function (entry) {
      return entry.isIntersecting;
    }).forEach(function (entry) {
      var target = entry.target;
      var url = target.dataset.src || '';
      loadImage(url).catch(function () {
        setImage(target, errorImage);
        addCssClassName(target, 'rc-lazyload__error');
        target.setAttribute('lazy', 'error');
      }).then(function (imagePath) {
        setImage(target, imagePath);
        setIsLoaded(true);
        addCssClassName(target, 'rc-lazyload__loaded');
        target.setAttribute('lazy', 'loaded');
        target.removeAttribute('data-src');
      });
    });
  }, [setIsLoaded, isLoaded]);
  var ref = useIntersectionObserver(observerOptions, handleIntersection);
  return [ref, isLoaded];
};
export default useImageVisible;