import _slicedToArray from "@babel/runtime/helpers/esm/slicedToArray";
import { useCallback, useEffect, useState } from 'react';
import { addCssClassName } from '.';
import useIntersectionObserver from './useIntersectionObserver';
var defaultObserverOptions = {
  threshold: [0, 1]
};
var useVisible = function useVisible(initialVisible) {
  var observerOptions = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : defaultObserverOptions;
  var _useState = useState(initialVisible),
    _useState2 = _slicedToArray(_useState, 2),
    visible = _useState2[0],
    setVisible = _useState2[1];
  var forceVisible = function forceVisible() {
    setVisible(true);
  };
  useEffect(function () {
    if (initialVisible) {
      forceVisible();
    }
  }, [initialVisible]);
  var handleIntersection = useCallback(function (entries) {
    entries.filter(function (entry) {
      return entry.isIntersecting;
    }).forEach(function (entry) {
      var target = entry.target;
      addCssClassName(target, 'rc-lazyload__loaded');
      setVisible(true);
    });
  }, [setVisible, visible]);
  var ref = useIntersectionObserver(observerOptions, handleIntersection);
  return [ref, visible];
};
export default useVisible;