import _slicedToArray from "@babel/runtime/helpers/esm/slicedToArray";
import React, { useContext, useMemo } from 'react';
import classnames from 'classnames';
import { addUnit } from '../utils';
import ConfigProviderContext from '../config-provider/ConfigProviderContext';
var Progress = function Progress(props) {
  var _useContext = useContext(ConfigProviderContext),
    prefixCls = _useContext.prefixCls,
    createNamespace = _useContext.createNamespace;
  var _createNamespace = createNamespace('progress', prefixCls),
    _createNamespace2 = _slicedToArray(_createNamespace, 1),
    bem = _createNamespace2[0];
  var inactive = props.inactive,
    color = props.color,
    trackColor = props.trackColor,
    percentage = props.percentage,
    strokeWidth = props.strokeWidth;
  var background = useMemo(function () {
    return inactive ? undefined : color;
  }, [inactive, color]);
  var renderPivot = function renderPivot() {
    var textColor = props.textColor,
      pivotText = props.pivotText,
      pivotColor = props.pivotColor;
    var text = pivotText !== null && pivotText !== void 0 ? pivotText : "".concat(percentage, "%");
    if (props.showPivot && text) {
      var style = {
        color: textColor,
        left: "".concat(+percentage, "%"),
        transform: "translate(-".concat(+percentage, "%,-50%)"),
        background: pivotColor || background
      };
      return /*#__PURE__*/React.createElement("span", {
        style: style,
        className: bem('pivot', {
          inactive: props.inactive
        })
      }, text);
    }
    return null;
  };
  var rootStyle = {
    background: trackColor,
    height: addUnit(strokeWidth)
  };
  var portionStyle = {
    width: "".concat(percentage, "%"),
    background: background
  };
  return /*#__PURE__*/React.createElement("div", {
    className: classnames(props.className, bem()),
    style: rootStyle
  }, /*#__PURE__*/React.createElement("span", {
    className: classnames(bem('portion', {
      inactive: props.inactive
    })),
    style: portionStyle
  }), renderPivot());
};
Progress.defaultProps = {
  percentage: 0,
  strokeWidth: '4px',
  color: '#1989fa',
  trackColor: '#e5e5e5',
  pivotColor: '',
  textColor: 'white',
  inactive: false,
  showPivot: true
};
export default Progress;