import _slicedToArray from "@babel/runtime/helpers/esm/slicedToArray";
import React, { useContext } from 'react';
import classNames from 'classnames';
import ConfigProviderContext from '../config-provider/ConfigProviderContext';
import SidebarContext from './SidebarContext';
var Sidebar = function Sidebar(props) {
  var _useContext = useContext(ConfigProviderContext),
    prefixCls = _useContext.prefixCls,
    createNamespace = _useContext.createNamespace;
  var _createNamespace = createNamespace('sidebar', prefixCls),
    _createNamespace2 = _slicedToArray(_createNamespace, 1),
    bem = _createNamespace2[0];
  var getActive = function getActive() {
    return +props.value;
  };
  var setActive = function setActive(value) {
    if (value !== getActive()) {
      var _props$onChange;
      (_props$onChange = props.onChange) === null || _props$onChange === void 0 ? void 0 : _props$onChange.call(props, value);
    }
  };
  return /*#__PURE__*/React.createElement(SidebarContext.Provider, {
    value: {
      getActive: getActive,
      setActive: setActive
    }
  }, /*#__PURE__*/React.createElement("div", {
    role: "tablist",
    className: classNames(bem())
  }, React.Children.toArray(props.children).filter(Boolean).map(function (child, index) {
    return /*#__PURE__*/React.cloneElement(child, {
      index: index
    });
  })));
};
Sidebar.defaultProps = {
  value: '0'
};
export default Sidebar;