import _slicedToArray from "@babel/runtime/helpers/esm/slicedToArray";
import React, { useContext } from 'react';
import classnames from 'classnames';
import { Badge } from '../badge';
import ConfigProviderContext from '../config-provider/ConfigProviderContext';
import SidebarContext from './SidebarContext';
var SidebarItem = function SidebarItem(props) {
  var _useContext = useContext(ConfigProviderContext),
    prefixCls = _useContext.prefixCls,
    createNamespace = _useContext.createNamespace;
  var _createNamespace = createNamespace('sidebar-item', prefixCls),
    _createNamespace2 = _slicedToArray(_createNamespace, 1),
    bem = _createNamespace2[0];
  var parent = useContext(SidebarContext);
  if (!Object.prototype.hasOwnProperty.call(parent, 'getActive')) {
    if (process.env.NODE_ENV !== 'production') {
      console.error('[rc-ui-lib] <SidebarItem> must be a child component of <Sidebar>.');
    }
    return null;
  }
  var dot = props.dot,
    badge = props.badge,
    title = props.title,
    disabled = props.disabled,
    index = props.index;
  var selected = index === parent.getActive();
  var onClick = function onClick() {
    var _props$onClick;
    if (props.disabled) {
      return;
    }
    (_props$onClick = props.onClick) === null || _props$onClick === void 0 ? void 0 : _props$onClick.call(props, index);
    parent.setActive(index);
  };
  return (
    /*#__PURE__*/
    // eslint-disable-next-line jsx-a11y/interactive-supports-focus
    React.createElement("div", {
      role: "tab",
      tabIndex: disabled ? undefined : 0,
      className: classnames(bem({
        select: selected,
        disabled: disabled
      })),
      "aria-selected": selected,
      onClick: onClick
    }, /*#__PURE__*/React.createElement(Badge, {
      dot: dot,
      content: badge,
      className: classnames(bem('text'))
    }, props.children ? props.children : title))
  );
};
export default SidebarItem;