import _slicedToArray from "@babel/runtime/helpers/esm/slicedToArray";
import React, { useRef, useEffect, useContext } from 'react';
import classnames from 'classnames';
import Swiper from '../swiper';
import ConfigProviderContext from '../config-provider/ConfigProviderContext';
var TabsContent = function TabsContent(props) {
  var _useContext = useContext(ConfigProviderContext),
    prefixCls = _useContext.prefixCls,
    createNamespace = _useContext.createNamespace;
  var _createNamespace = createNamespace('tabs', prefixCls),
    _createNamespace2 = _slicedToArray(_createNamespace, 1),
    bem = _createNamespace2[0];
  var swipeRef = useRef();
  var innerEffect = useRef(false);
  var animated = props.animated,
    swipeable = props.swipeable,
    duration = props.duration;
  var renderChildren = function renderChildren() {
    if (animated || swipeable) {
      return /*#__PURE__*/React.createElement(Swiper, {
        ref: swipeRef,
        loop: false,
        autoplay: false,
        allowTouchMove: swipeable,
        className: classnames(bem('track')),
        autoplayInterval: +duration,
        indicator: false,
        onIndexChange: function onIndexChange(idx) {
          var _props$onChange;
          if (innerEffect.current) {
            innerEffect.current = false;
            return;
          }
          (_props$onChange = props.onChange) === null || _props$onChange === void 0 ? void 0 : _props$onChange.call(props, idx);
        }
      }, React.Children.map(props.children, function (child) {
        return /*#__PURE__*/React.createElement(Swiper.Item, {
          style: {
            cursor: !swipeable ? 'auto' : undefined
          },
          className: classnames(bem('pane-wrapper'))
        }, child);
      }));
    }
    return props.children;
  };
  var swipeToCurrentTab = function swipeToCurrentTab(index) {
    var swipe = swipeRef.current;
    if (!swipe) return;
    if (swipe.activeIndex !== index) {
      innerEffect.current = true;
      swipe.swipeTo(index);
    }
  };
  useEffect(function () {
    swipeToCurrentTab(props.currentIndex);
  }, [props.currentIndex]);
  return /*#__PURE__*/React.createElement("div", {
    className: classnames(bem('content', {
      animated: animated || swipeable
    }))
  }, renderChildren());
};
export default TabsContent;