import _defineProperty from "@babel/runtime/helpers/esm/defineProperty";
import _slicedToArray from "@babel/runtime/helpers/esm/slicedToArray";
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
import React, { useMemo, useRef, useContext } from 'react';
import classnames from 'classnames';
import { CSSTransition } from 'react-transition-group';
import Icon from '../icon';
import ConfigProviderContext from '../config-provider/ConfigProviderContext';
var Tag = function Tag(props) {
  var _useContext = useContext(ConfigProviderContext),
    prefixCls = _useContext.prefixCls,
    createNamespace = _useContext.createNamespace;
  var _createNamespace = createNamespace('tag', prefixCls),
    _createNamespace2 = _slicedToArray(_createNamespace, 1),
    bem = _createNamespace2[0];
  var nodeRef = useRef(null);
  var visible = props.visible,
    plain = props.plain,
    textColor = props.textColor,
    color = props.color,
    type = props.type,
    mark = props.mark,
    round = props.round,
    size = props.size,
    closeable = props.closeable,
    onClick = props.onClick,
    onClose = props.onClose,
    children = props.children;
  var handleClose = function handleClose(event) {
    event.stopPropagation();
    onClose === null || onClose === void 0 ? void 0 : onClose(event);
  };
  var getStyle = useMemo(function () {
    if (plain) {
      return {
        color: textColor || color,
        borderColor: color
      };
    }
    return {
      color: textColor,
      background: color
    };
  }, [textColor, color, plain]);
  var renderTag = function renderTag() {
    var classes = {
      mark: mark,
      plain: plain,
      round: round
    };
    if (size) {
      classes[size] = size;
    }
    var CloseIcon = closeable && /*#__PURE__*/React.createElement(Icon, {
      name: "cross",
      className: classnames(bem('close')),
      onClick: handleClose
    });
    return /*#__PURE__*/React.createElement("span", {
      ref: nodeRef,
      style: _objectSpread(_objectSpread({}, getStyle), props.style),
      className: classnames(props.className, bem([classes, type])),
      onClick: onClick
    }, children, CloseIcon);
  };
  return /*#__PURE__*/React.createElement(CSSTransition, {
    nodeRef: nodeRef,
    classNames: "rc-fade",
    in: visible,
    timeout: 300,
    unmountOnExit: true
  }, renderTag());
};
Tag.defaultProps = {
  visible: true,
  type: 'default'
};
export default Tag;