"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
function _extends2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/extends"));
  _extends2 = function _extends2() {
    return data;
  };
  return data;
}
function _toConsumableArray2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));
  _toConsumableArray2 = function _toConsumableArray2() {
    return data;
  };
  return data;
}
function _slicedToArray2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));
  _slicedToArray2 = function _slicedToArray2() {
    return data;
  };
  return data;
}
function _react() {
  var data = _interopRequireWildcard(require("react"));
  _react = function _react() {
    return data;
  };
  return data;
}
function _classnames() {
  var data = _interopRequireDefault(require("classnames"));
  _classnames = function _classnames() {
    return data;
  };
  return data;
}
var _popup = require("../popup");
var _button = _interopRequireDefault(require("../button"));
var _index = _interopRequireDefault(require("../toast/index"));
var _CalendarHeader = _interopRequireDefault(require("./CalendarHeader"));
var _CalendarMonth = _interopRequireDefault(require("./CalendarMonth"));
var _hooks = require("../hooks");
var _getRect = require("../hooks/get-rect");
var _useRefs3 = _interopRequireDefault(require("../hooks/use-refs"));
var _utils = require("./utils");
var _utils2 = require("../utils");
var _raf = require("../utils/raf");
var _ConfigProviderContext = _interopRequireDefault(require("../config-provider/ConfigProviderContext"));
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
/* eslint-disable @typescript-eslint/no-shadow */
/* eslint-disable no-plusplus */

var Calendar = /*#__PURE__*/(0, _react().forwardRef)(function (props, ref) {
  var _useContext = (0, _react().useContext)(_ConfigProviderContext.default),
    prefixCls = _useContext.prefixCls,
    createNamespace = _useContext.createNamespace;
  var _createNamespace = createNamespace('calendar', prefixCls),
    _createNamespace2 = (0, _slicedToArray2().default)(_createNamespace, 1),
    bem = _createNamespace2[0];
  var type = props.type,
    title = props.title,
    showTitle = props.showTitle,
    showSubtitle = props.showSubtitle,
    firstDayOfWeek = props.firstDayOfWeek,
    minDate = props.minDate,
    maxDate = props.maxDate,
    safeAreaInsetBottom = props.safeAreaInsetBottom,
    footer = props.footer,
    showConfirm = props.showConfirm,
    className = props.className,
    style = props.style;
  var limitDateRange = function limitDateRange(date) {
    var minDate = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : props.minDate;
    var maxDate = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : props.maxDate;
    if ((0, _utils.compareDay)(date, minDate) === -1) {
      return minDate;
    }
    if ((0, _utils.compareDay)(date, maxDate) === 1) {
      return maxDate;
    }
    return date;
  };
  var getInitialDate = function getInitialDate() {
    var defaultDate = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : props.defaultDate;
    if (defaultDate === null) {
      return defaultDate;
    }
    var now = (0, _utils.getToday)();
    if (type === 'range') {
      if (!Array.isArray(defaultDate)) {
        defaultDate = [];
      }
      var start = limitDateRange(defaultDate[0] || now, minDate, (0, _utils.getPrevDay)(maxDate));
      var end = limitDateRange(defaultDate[1] || now, (0, _utils.getNextDay)(minDate));
      return [start, end];
    }
    if (type === 'multiple') {
      if (Array.isArray(defaultDate)) {
        return defaultDate.map(function (date) {
          return limitDateRange(date);
        });
      }
      return [limitDateRange(now)];
    }
    if (!defaultDate || Array.isArray(defaultDate)) {
      defaultDate = now;
    }
    return limitDateRange(defaultDate);
  };
  var bodyRef = (0, _react().useRef)(null);
  var bodyHeightRef = (0, _react().useRef)(0);
  var _useState = (0, _react().useState)(''),
    _useState2 = (0, _slicedToArray2().default)(_useState, 2),
    subtitle = _useState2[0],
    setSubtitle = _useState2[1];
  var _useState3 = (0, _react().useState)(getInitialDate()),
    _useState4 = (0, _slicedToArray2().default)(_useState3, 2),
    currentDate = _useState4[0],
    setCurrentDate = _useState4[1];
  var _useRefs = (0, _useRefs3.default)(),
    _useRefs2 = (0, _slicedToArray2().default)(_useRefs, 2),
    monthRefs = _useRefs2[0],
    setMonthRefs = _useRefs2[1];
  var dayOffset = (0, _react().useMemo)(function () {
    return firstDayOfWeek ? +firstDayOfWeek % 7 : 0;
  }, [firstDayOfWeek]);
  var monthsList = (0, _react().useMemo)(function () {
    var months = [];
    var cursor = new Date(minDate);
    cursor.setDate(1);
    do {
      months.push(new Date(cursor));
      cursor.setMonth(cursor.getMonth() + 1);
    } while ((0, _utils.compareMonth)(cursor, maxDate) !== 1);
    return months;
  }, [minDate, maxDate]);
  var buttonDisabled = (0, _react().useMemo)(function () {
    if (currentDate) {
      if (props.type === 'range') {
        return !currentDate[0] || !currentDate[1];
      }
      if (props.type === 'multiple') {
        return !currentDate.length;
      }
    }
    return !currentDate;
  }, [props.type, currentDate]);
  var onScroll = function onScroll() {
    if (!bodyRef.current) return;
    var top = (0, _utils2.getScrollTop)(bodyRef.current);
    var bottom = top + bodyHeightRef.current;
    var heights = monthsList.map(function (_, index) {
      return monthRefs[index].getHeight();
    });
    var heightSum = heights.reduce(function (a, b) {
      return a + b;
    }, 0);

    // iOS scroll bounce may exceed the range
    if (bottom > heightSum && top > 0) {
      return;
    }
    var height = 0;
    var currentMonth;
    var visibleRange = [-1, -1];
    for (var i = 0; i < monthsList.length; i++) {
      var month = monthRefs[i];
      var visible = height <= bottom && height + heights[i] >= top;
      if (visible) {
        visibleRange[1] = i;
        if (!currentMonth) {
          currentMonth = month;
          visibleRange[0] = i;
        }
        if (!monthRefs[i].showed) {
          var _props$onMonthShow;
          monthRefs[i].showed = true;
          (_props$onMonthShow = props.onMonthShow) === null || _props$onMonthShow === void 0 ? void 0 : _props$onMonthShow.call(props, {
            date: month.date,
            title: month.getTitle()
          });
        }
      }
      height += heights[i];
    }
    monthsList.forEach(function (_, index) {
      var visible = index >= visibleRange[0] - 1 && index <= visibleRange[1] + 1;
      monthRefs[index].setVisible(visible);
    });

    /* istanbul ignore else */
    if (currentMonth) {
      setSubtitle(currentMonth.getTitle());
    }
  };
  var scrollToDate = function scrollToDate(targetDate) {
    (0, _raf.raf)(function () {
      monthsList.some(function (month, index) {
        if ((0, _utils.compareMonth)(month, targetDate) === 0) {
          if (bodyRef.current) {
            monthRefs[index].scrollToDate(bodyRef.current, targetDate);
          }
          return true;
        }
        return false;
      });
      onScroll();
    });
  };
  var scrollToCurrentDate = function scrollToCurrentDate(date) {
    if (props.poppable && !props.show) {
      return;
    }
    var currentDate = date || getInitialDate();
    if (currentDate) {
      var targetDate = props.type === 'single' ? currentDate : currentDate[0];
      scrollToDate(targetDate);
    } else {
      (0, _raf.raf)(onScroll);
    }
  };
  var init = function init() {
    if (props.poppable && !props.show) {
      return;
    }
    (0, _raf.raf)(function () {
      bodyHeightRef.current = Math.floor((0, _getRect.getRect)(bodyRef.current).height);
      scrollToCurrentDate();
    });
  };
  var reset = function reset() {
    var date = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : getInitialDate();
    setCurrentDate(date);
    scrollToCurrentDate(date);
  };
  var onConfirm = function onConfirm(date) {
    var _props$onConfirm;
    (_props$onConfirm = props.onConfirm) === null || _props$onConfirm === void 0 ? void 0 : _props$onConfirm.call(props, (0, _utils.cloneDates)(date || currentDate));
  };
  var checkRange = function checkRange(date) {
    var maxRange = props.maxRange,
      rangePrompt = props.rangePrompt,
      showRangePrompt = props.showRangePrompt;
    if (maxRange && (0, _utils.calcDateNum)(date) > maxRange) {
      var _props$onOverRange;
      if (showRangePrompt) {
        (0, _index.default)(rangePrompt || (0, _utils.t)('rangePrompt', maxRange));
      }
      (_props$onOverRange = props.onOverRange) === null || _props$onOverRange === void 0 ? void 0 : _props$onOverRange.call(props);
      return false;
    }
    return true;
  };
  var select = function select(date, complete) {
    var toSetCurrentDate = function toSetCurrentDate(date) {
      var _props$onSelect;
      setCurrentDate(date);
      (_props$onSelect = props.onSelect) === null || _props$onSelect === void 0 ? void 0 : _props$onSelect.call(props, (0, _utils.cloneDates)(date));
    };
    if (complete && props.type === 'range') {
      var valid = checkRange(date);
      if (!valid) {
        // auto selected to max range
        toSetCurrentDate([date[0], (0, _utils.getDayByOffset)(date[0], +props.maxRange - 1)]);
        return;
      }
    }
    toSetCurrentDate(date);
    if (complete && !props.showConfirm) {
      onConfirm(date);
    }
  };
  var onClickDay = function onClickDay(item) {
    if (props.readonly || !item.date) {
      return;
    }
    var date = item.date;
    var type = props.type;
    if (type === 'range') {
      if (!currentDate) {
        select([date]);
        return;
      }
      var _ref = currentDate,
        _ref2 = (0, _slicedToArray2().default)(_ref, 2),
        startDay = _ref2[0],
        endDay = _ref2[1];
      if (startDay && !endDay) {
        var compareToStart = (0, _utils.compareDay)(date, startDay);
        if (compareToStart === 1) {
          select([startDay, date], true);
        } else if (compareToStart === -1) {
          select([date]);
        } else if (props.allowSameDay) {
          select([date, date], true);
        }
      } else {
        select([date]);
      }
    } else if (type === 'multiple') {
      if (!currentDate) {
        select([date]);
        return;
      }
      var dates = currentDate;
      var selectedIndex = dates.findIndex(function (dateItem) {
        return (0, _utils.compareDay)(dateItem, date) === 0;
      });
      if (selectedIndex !== -1) {
        var _props$onUnselect;
        var _dates$splice = dates.splice(selectedIndex, 1),
          _dates$splice2 = (0, _slicedToArray2().default)(_dates$splice, 1),
          unselectedDate = _dates$splice2[0];
        (_props$onUnselect = props.onUnselect) === null || _props$onUnselect === void 0 ? void 0 : _props$onUnselect.call(props, (0, _utils.cloneDate)(unselectedDate));
        setCurrentDate((0, _toConsumableArray2().default)(dates));
      } else if (props.maxRange && dates.length >= props.maxRange) {
        (0, _index.default)(props.rangePrompt || (0, _utils.t)('rangePrompt', props.maxRange));
      } else {
        select([].concat((0, _toConsumableArray2().default)(dates), [date]));
      }
    } else {
      select(date, true);
    }
  };
  var renderMonth = function renderMonth(date, index) {
    var showMonthTitle = index !== 0 || !props.showSubtitle;
    return /*#__PURE__*/_react().default.createElement(_CalendarMonth.default, (0, _extends2().default)({
      key: index,
      ref: setMonthRefs(index),
      date: date,
      currentDate: currentDate,
      showMonthTitle: showMonthTitle,
      firstDayOfWeek: dayOffset
    }, (0, _utils2.pick)(props, ['type', 'color', 'minDate', 'maxDate', 'showMark', 'formatter', 'rowHeight', 'lazyRender', 'showSubtitle', 'allowSameDay']), {
      onClick: onClickDay
    }));
  };
  var renderFooter = function renderFooter() {
    var disabled = buttonDisabled;
    var text = disabled ? props.confirmDisabledText : props.confirmText;
    return /*#__PURE__*/_react().default.createElement("div", {
      className: (0, _classnames().default)(bem('footer'), {
        'rc-safe-area-bottom': safeAreaInsetBottom
      })
    }, footer || (showConfirm ? /*#__PURE__*/_react().default.createElement(_button.default, {
      round: true,
      block: true,
      type: "danger",
      color: props.color,
      className: (0, _classnames().default)(bem('confirm')),
      disabled: buttonDisabled,
      nativeType: "button",
      onClick: function onClick() {
        return onConfirm();
      }
    }, text || '确认') : null));
  };
  var renderCalendar = function renderCalendar() {
    return /*#__PURE__*/_react().default.createElement("div", {
      className: (0, _classnames().default)(bem(), className),
      style: style
    }, /*#__PURE__*/_react().default.createElement(_CalendarHeader.default, {
      title: title,
      subtitle: props.subtitle || subtitle,
      showTitle: showTitle,
      showSubtitle: showSubtitle,
      firstDayOfWeek: firstDayOfWeek,
      onClickSubtitle: function onClickSubtitle(event) {
        var _props$onClickSubtitl;
        (_props$onClickSubtitl = props.onClickSubtitle) === null || _props$onClickSubtitl === void 0 ? void 0 : _props$onClickSubtitl.call(props, event);
      }
    }), /*#__PURE__*/_react().default.createElement("div", {
      ref: bodyRef,
      className: (0, _classnames().default)(bem('body')),
      onScroll: onScroll
    }, monthsList.map(renderMonth)), renderFooter());
  };
  (0, _react().useEffect)(function () {
    init();
  }, [props.show]);
  (0, _hooks.useUpdateEffect)(function () {
    reset(getInitialDate());
  }, [props.type, props.minDate, props.maxDate]);
  (0, _hooks.useUpdateEffect)(function () {
    setCurrentDate(props.defaultDate);
    scrollToCurrentDate();
  }, [props.defaultDate]);
  (0, _react().useImperativeHandle)(ref, function () {
    return {
      reset: reset,
      scrollToDate: scrollToDate
    };
  });
  return props.poppable ? /*#__PURE__*/_react().default.createElement(_popup.Popup, {
    visible: props.show,
    className: (0, _classnames().default)(bem('popup')),
    round: props.round,
    position: props.position,
    closeable: props.showTitle || props.showSubtitle,
    teleport: props.teleport,
    closeOnClickOverlay: props.closeOnClickOverlay,
    closeOnPopstate: props.closeOnPopstate,
    onClose: function onClose() {
      var _props$onClose;
      return (_props$onClose = props.onClose) === null || _props$onClose === void 0 ? void 0 : _props$onClose.call(props);
    }
  }, renderCalendar()) : /*#__PURE__*/_react().default.createElement(_react().default.Fragment, null, renderCalendar());
});
Calendar.defaultProps = {
  type: 'single',
  title: '日期选择',
  color: '#ee0a24',
  rowHeight: 64,
  poppable: true,
  lazyRender: true,
  showMark: true,
  showTitle: true,
  showSubtitle: true,
  showConfirm: true,
  showRangePrompt: true,
  readonly: false,
  firstDayOfWeek: 0,
  footer: null,
  minDate: (0, _utils.getToday)(),
  maxDate: function () {
    var now = (0, _utils.getToday)();
    return new Date(now.getFullYear(), now.getMonth() + 6, now.getDate());
  }(),
  show: false,
  position: 'bottom',
  round: true,
  closeOnPopstate: true,
  closeOnClickOverlay: true,
  safeAreaInsetBottom: true,
  maxRange: null,
  allowSameDay: false
};
var _default = Calendar;
exports.default = _default;