"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
function _slicedToArray2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));
  _slicedToArray2 = function _slicedToArray2() {
    return data;
  };
  return data;
}
function _react() {
  var data = _interopRequireWildcard(require("react"));
  _react = function _react() {
    return data;
  };
  return data;
}
function _classnames() {
  var data = _interopRequireDefault(require("classnames"));
  _classnames = function _classnames() {
    return data;
  };
  return data;
}
var _ConfigProviderContext = _interopRequireDefault(require("../config-provider/ConfigProviderContext"));
var _utils = require("./utils");
var _useCountDown2 = require("../hooks/use-count-down");
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
var CountDown = /*#__PURE__*/(0, _react().forwardRef)(function (props, ref) {
  var time = props.time,
    format = props.format,
    autoStart = props.autoStart,
    millisecond = props.millisecond,
    renderChildren = props.renderChildren;
  var _useCountDown = (0, _useCountDown2.useCountDown)({
      time: +time,
      millisecond: millisecond,
      onChange: function onChange(value) {
        var _props$onChange;
        return (_props$onChange = props.onChange) === null || _props$onChange === void 0 ? void 0 : _props$onChange.call(props, value);
      },
      onFinish: props.onFinish
    }),
    start = _useCountDown.start,
    pause = _useCountDown.pause,
    reset = _useCountDown.reset,
    current = _useCountDown.current;
  var timeText = (0, _react().useMemo)(function () {
    return (0, _utils.parseFormat)(format, current);
  }, [format, current]);
  var resetTime = function resetTime() {
    reset(+time);
    if (autoStart) {
      start();
    }
  };
  (0, _react().useEffect)(function () {
    resetTime();
  }, [time]);
  (0, _react().useImperativeHandle)(ref, function () {
    return {
      start: start,
      pause: pause,
      reset: resetTime
    };
  });
  var _useContext = (0, _react().useContext)(_ConfigProviderContext.default),
    prefixCls = _useContext.prefixCls,
    createNamespace = _useContext.createNamespace;
  var _createNamespace = createNamespace('count-down', prefixCls),
    _createNamespace2 = (0, _slicedToArray2().default)(_createNamespace, 1),
    bem = _createNamespace2[0];
  return /*#__PURE__*/_react().default.createElement("div", {
    role: "timer",
    className: (0, _classnames().default)(bem())
  }, renderChildren ? renderChildren(current) : timeText);
});
CountDown.defaultProps = {
  time: 0,
  format: 'HH:mm:ss',
  autoStart: true,
  millisecond: false
};
var _default = CountDown;
exports.default = _default;