"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
function _extends2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/extends"));
  _extends2 = function _extends2() {
    return data;
  };
  return data;
}
function _defineProperty2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
  _defineProperty2 = function _defineProperty2() {
    return data;
  };
  return data;
}
function _slicedToArray2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));
  _slicedToArray2 = function _slicedToArray2() {
    return data;
  };
  return data;
}
function _objectWithoutProperties2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));
  _objectWithoutProperties2 = function _objectWithoutProperties2() {
    return data;
  };
  return data;
}
function _react() {
  var data = _interopRequireWildcard(require("react"));
  _react = function _react() {
    return data;
  };
  return data;
}
var _picker = _interopRequireDefault(require("../picker"));
var _utils = require("./utils");
var _hooks = require("../hooks");
var _date = require("../utils/validate/date");
var _utils2 = require("../utils");
var _raf = require("../utils/raf");
var _excluded = ["value", "formatter", "columnsOrder", "type", "filter", "minDate", "maxDate"];
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
var DatePicker = /*#__PURE__*/(0, _react().forwardRef)(function (props, ref) {
  var value = props.value,
    formatter = props.formatter,
    columnsOrder = props.columnsOrder,
    datePickerType = props.type,
    filter = props.filter,
    datePickerMinDate = props.minDate,
    datePickerMaxDate = props.maxDate,
    pickerProps = (0, _objectWithoutProperties2().default)(props, _excluded);
  var formatValue = function formatValue(date) {
    if (!(0, _date.isDate)(date)) {
      date = props.minDate;
    }
    date = Math.max(date, props.minDate.getTime());
    date = Math.min(date, props.maxDate.getTime());
    return new Date(date);
  };
  var pickerRef = (0, _react().useRef)(null);
  var _useState = (0, _react().useState)(formatValue(value)),
    _useState2 = (0, _slicedToArray2().default)(_useState, 2),
    currentDate = _useState2[0],
    setCurrentDate = _useState2[1];
  var currentDateRef = (0, _react().useRef)(currentDate);
  var getBoundary = function getBoundary(type, dateValue) {
    var _ref;
    var boundary = props["".concat(type, "Date")];
    var year = boundary.getFullYear();
    var month = 1;
    var date = 1;
    var hour = 0;
    var minute = 0;
    if (type === 'max') {
      month = 12;
      date = (0, _utils.getMonthEndDay)(dateValue.getFullYear(), dateValue.getMonth() + 1);
      hour = 23;
      minute = 59;
    }
    if (dateValue.getFullYear() === year) {
      month = boundary.getMonth() + 1;
      if (dateValue.getMonth() + 1 === month) {
        date = boundary.getDate();
        if (dateValue.getDate() === date) {
          hour = boundary.getHours();
          if (dateValue.getHours() === hour) {
            minute = boundary.getMinutes();
          }
        }
      }
    }
    return _ref = {}, (0, _defineProperty2().default)(_ref, "".concat(type, "Year"), year), (0, _defineProperty2().default)(_ref, "".concat(type, "Month"), month), (0, _defineProperty2().default)(_ref, "".concat(type, "Date"), date), (0, _defineProperty2().default)(_ref, "".concat(type, "Hour"), hour), (0, _defineProperty2().default)(_ref, "".concat(type, "Minute"), minute), _ref;
  };
  var ranges = (0, _react().useMemo)(function () {
    var _getBoundary = getBoundary('max', currentDateRef.current),
      maxYear = _getBoundary.maxYear,
      maxDate = _getBoundary.maxDate,
      maxMonth = _getBoundary.maxMonth,
      maxHour = _getBoundary.maxHour,
      maxMinute = _getBoundary.maxMinute;
    var _getBoundary2 = getBoundary('min', currentDateRef.current),
      minYear = _getBoundary2.minYear,
      minDate = _getBoundary2.minDate,
      minMonth = _getBoundary2.minMonth,
      minHour = _getBoundary2.minHour,
      minMinute = _getBoundary2.minMinute;
    var result = [{
      type: 'year',
      range: [minYear, maxYear]
    }, {
      type: 'month',
      range: [minMonth, maxMonth]
    }, {
      type: 'day',
      range: [minDate, maxDate]
    }, {
      type: 'hour',
      range: [minHour, maxHour]
    }, {
      type: 'minute',
      range: [minMinute, maxMinute]
    }];
    switch (props.type) {
      case 'date':
        result = result.slice(0, 3);
        break;
      case 'year-month':
        result = result.slice(0, 2);
        break;
      case 'month-day':
        result = result.slice(1, 3);
        break;
      case 'datehour':
        result = result.slice(0, 4);
        break;
      default:
        break;
    }
    if (columnsOrder) {
      var columnsOrderArr = columnsOrder.concat(result.map(function (column) {
        return column.type;
      }));
      result.sort(function (a, b) {
        return columnsOrderArr.indexOf(a.type) - columnsOrderArr.indexOf(b.type);
      });
    }
    return result;
  }, [columnsOrder, props.type]);
  var originColumns = (0, _react().useMemo)(function () {
    return ranges.map(function (_ref2) {
      var type = _ref2.type,
        rangeArr = _ref2.range;
      // 根据范围获取每列的值
      var values = (0, _utils.times)(rangeArr[1] - rangeArr[0] + 1, function (index) {
        return (0, _utils2.padZero)(rangeArr[0] + index);
      });
      if (filter) {
        values = filter(type, values);
      }
      return {
        type: type,
        values: values
      };
    });
  }, [filter, ranges]);
  var columns = (0, _react().useMemo)(function () {
    return originColumns.map(function (column) {
      return {
        values: column.values.map(function (e) {
          return formatter(column.type, e);
        })
      };
    });
  }, [originColumns, formatter]);
  var updateColumnValue = (0, _react().useCallback)(function () {
    var values = originColumns.map(function (column) {
      switch (column.type) {
        case 'year':
          return formatter('year', "".concat(currentDate.getFullYear()));
        case 'month':
          return formatter('month', (0, _utils2.padZero)(currentDate.getMonth() + 1));
        case 'day':
          return formatter('day', (0, _utils2.padZero)(currentDate.getDate()));
        case 'hour':
          return formatter('hour', (0, _utils2.padZero)(currentDate.getHours()));
        case 'minute':
          return formatter('minute', (0, _utils2.padZero)(currentDate.getMinutes()));
        default:
          // no default
          return null;
      }
    });
    (0, _raf.doubleRaf)(function () {
      var _pickerRef$current;
      (_pickerRef$current = pickerRef.current) === null || _pickerRef$current === void 0 ? void 0 : _pickerRef$current.setValues(values);
    });
  }, [currentDate, formatter, originColumns]);
  var updateInnerValue = function updateInnerValue(indexes) {
    var type = props.type;
    var getValue = function getValue(datetimePickerColumnType) {
      var index = 0;
      originColumns.forEach(function (column, columnIndex) {
        if (datetimePickerColumnType === column.type) {
          index = columnIndex;
        }
      });
      var values = originColumns[index].values;
      return (0, _utils.getTrueValue)(values[indexes[index]]);
    };
    var year = null;
    var month = null;
    var day = null;
    if (type === 'month-day') {
      year = (currentDate || props.minDate).getFullYear();
      month = getValue('month');
      day = getValue('day');
    } else {
      year = getValue('year');
      month = getValue('month');
      day = type === 'year-month' ? 1 : getValue('day');
    }
    var maxDay = (0, _utils.getMonthEndDay)(year, month);
    day = day > maxDay ? maxDay : day;
    var hour = 0;
    var minute = 0;
    if (type === 'datehour') {
      hour = +getValue('hour');
    }
    if (type === 'datetime') {
      hour = +getValue('hour');
      minute = +getValue('minute');
    }
    return formatValue(new Date(year, month - 1, day, hour, minute));
  };
  var onChange = function onChange(val, index) {
    if (pickerRef.current) {
      var _props$onChange;
      var indexes = pickerRef.current.getIndexes();
      var nextValue = updateInnerValue(indexes);
      setCurrentDate(nextValue);
      currentDateRef.current = nextValue;
      (_props$onChange = props.onChange) === null || _props$onChange === void 0 ? void 0 : _props$onChange.call(props, nextValue);
    }
  };
  var onConfirm = function onConfirm() {
    var _props$onConfirm;
    (_props$onConfirm = props.onConfirm) === null || _props$onConfirm === void 0 ? void 0 : _props$onConfirm.call(props, currentDate);
  };
  (0, _hooks.useMount)(function () {
    setTimeout(function () {
      if (pickerRef.current) {
        var _pickerRef$current2;
        var indexes = (_pickerRef$current2 = pickerRef.current) === null || _pickerRef$current2 === void 0 ? void 0 : _pickerRef$current2.getIndexes();
        var nextValue = updateInnerValue(indexes);
        setCurrentDate(nextValue);
        currentDateRef.current = nextValue;
      }
    }, 0);
  });
  (0, _react().useEffect)(function () {
    updateColumnValue();
  }, [updateColumnValue]);
  var minDate = props.minDate,
    maxDate = props.maxDate;
  (0, _hooks.useUpdateEffect)(function () {
    var nextValue = formatValue(value);
    if (nextValue && nextValue.valueOf() !== (currentDate === null || currentDate === void 0 ? void 0 : currentDate.valueOf())) {
      setCurrentDate(nextValue);
      currentDateRef.current = nextValue;
    }
  }, [value, filter, minDate, maxDate]);
  (0, _react().useImperativeHandle)(ref, function () {
    return {
      getPicker: function getPicker() {
        return pickerRef.current;
      }
    };
  });
  return /*#__PURE__*/_react().default.createElement(_picker.default, (0, _extends2().default)({}, pickerProps, {
    ref: pickerRef,
    columns: columns,
    onChange: onChange,
    onConfirm: onConfirm,
    onCancel: props.onCancel
  }));
});
var currentYear = new Date().getFullYear();
DatePicker.defaultProps = {
  type: 'datetime',
  minDate: new Date(currentYear - 10, 0, 1),
  maxDate: new Date(currentYear + 10, 11, 31),
  formatter: function formatter(type, value) {
    return value;
  }
};
DatePicker.displayName = 'DatePicker';
var _default = DatePicker;
exports.default = _default;