"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof3 = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
function _extends2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/extends"));
  _extends2 = function _extends2() {
    return data;
  };
  return data;
}
function _toConsumableArray2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));
  _toConsumableArray2 = function _toConsumableArray2() {
    return data;
  };
  return data;
}
function _typeof2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/typeof"));
  _typeof2 = function _typeof2() {
    return data;
  };
  return data;
}
function _defineProperty2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
  _defineProperty2 = function _defineProperty2() {
    return data;
  };
  return data;
}
function _slicedToArray2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));
  _slicedToArray2 = function _slicedToArray2() {
    return data;
  };
  return data;
}
function _objectWithoutProperties2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));
  _objectWithoutProperties2 = function _objectWithoutProperties2() {
    return data;
  };
  return data;
}
function _react() {
  var data = _interopRequireWildcard(require("react"));
  _react = function _react() {
    return data;
  };
  return data;
}
function _classnames() {
  var data = _interopRequireDefault(require("classnames"));
  _classnames = function _classnames() {
    return data;
  };
  return data;
}
function _rcFieldForm() {
  var data = require("rc-field-form");
  _rcFieldForm = function _rcFieldForm() {
    return data;
  };
  return data;
}
function _FieldContext() {
  var data = _interopRequireDefault(require("rc-field-form/lib/FieldContext"));
  _FieldContext = function _FieldContext() {
    return data;
  };
  return data;
}
var _field = _interopRequireDefault(require("../field"));
var _utils = require("../uploader/utils");
var _Field = require("../field/Field");
var _constant = require("../utils/constant");
var _FormContext = require("./FormContext");
var _ConfigProviderContext = _interopRequireDefault(require("../config-provider/ConfigProviderContext"));
var _excluded = ["children"],
  _excluded2 = ["className", "meta", "children", "isFieldChildren", "showValidateMessage", "colon", "layout", "validateTrigger"],
  _excluded3 = ["className", "style", "label", "name", "required", "noStyle", "tooltip", "intro", "customField", "disabled", "colon", "rules", "children", "messageVariables", "trigger", "validateTrigger", "onClick", "shouldUpdate", "dependencies", "labelWidth", "labelAlign", "labelClass", "showValidateMessage"];
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof3(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2().default)(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function devWarning(component, message) {
  if (process.env.NODE_ENV !== 'production') {
    console.warn("[".concat(component, "] ").concat(message));
  }
}
var MemoInput = /*#__PURE__*/_react().default.memo(function (_ref) {
  var children = _ref.children,
    props = (0, _objectWithoutProperties2().default)(_ref, _excluded);
  return /*#__PURE__*/_react().default.cloneElement(children, props);
}, function (prev, next) {
  return prev.value === next.value && prev.update === next.update;
});
var FormItemLayout = function FormItemLayout(props) {
  var className = props.className,
    meta = props.meta,
    children = props.children,
    isFieldChildren = props.isFieldChildren,
    showValidateMessage = props.showValidateMessage,
    colon = props.colon,
    layout = props.layout,
    validateTrigger = props.validateTrigger,
    fieldProps = (0, _objectWithoutProperties2().default)(props, _excluded2);
  var _useContext = (0, _react().useContext)(_ConfigProviderContext.default),
    prefixCls = _useContext.prefixCls,
    createNamespace = _useContext.createNamespace;
  var _createNamespace = createNamespace('form', prefixCls),
    _createNamespace2 = (0, _slicedToArray2().default)(_createNamespace, 1),
    bem = _createNamespace2[0];
  var context = (0, _react().useContext)(_FormContext.FormContext);
  var itemLayout = layout !== null && layout !== void 0 ? layout : context.layout;
  var itemColon = colon !== null && colon !== void 0 ? colon : context.colon;
  var itemValidateTrigger = validateTrigger !== null && validateTrigger !== void 0 ? validateTrigger : context.validateTrigger;
  var itemShowValidateMessage = showValidateMessage !== null && showValidateMessage !== void 0 ? showValidateMessage : context.showValidateMessage;
  var error = meta && meta.errors.length > 0;
  var errorMessage = itemShowValidateMessage && error ? meta.errors[0] : null;
  var attrs = _objectSpread(_objectSpread({}, fieldProps), {}, {
    className: (0, _classnames().default)(bem({
      vertical: itemLayout === 'vertical' && !isFieldChildren
    }), className),
    colon: itemColon,
    error: error,
    errorMessage: errorMessage,
    validateTrigger: itemValidateTrigger
  });
  if (isFieldChildren) return /*#__PURE__*/_react().default.cloneElement(children, attrs);
  return /*#__PURE__*/_react().default.createElement(_field.default, attrs, children);
};
var FormItem = function FormItem(props) {
  var _type;
  var className = props.className,
    style = props.style,
    label = props.label,
    name = props.name,
    required = props.required,
    noStyle = props.noStyle,
    tooltip = props.tooltip,
    intro = props.intro,
    customField = props.customField,
    disabled = props.disabled,
    colon = props.colon,
    rules = props.rules,
    children = props.children,
    messageVariables = props.messageVariables,
    trigger = props.trigger,
    _props$validateTrigge = props.validateTrigger,
    validateTrigger = _props$validateTrigge === void 0 ? trigger : _props$validateTrigge,
    onClick = props.onClick,
    shouldUpdate = props.shouldUpdate,
    dependencies = props.dependencies,
    labelWidth = props.labelWidth,
    labelAlign = props.labelAlign,
    labelClass = props.labelClass,
    showValidateMessage = props.showValidateMessage,
    fieldProps = (0, _objectWithoutProperties2().default)(props, _excluded3);
  var _useContext2 = (0, _react().useContext)(_FieldContext().default),
    contextValidateTrigger = _useContext2.validateTrigger;
  var mergedValidateTrigger = validateTrigger !== undefined ? validateTrigger : contextValidateTrigger;
  var updateRef = (0, _react().useRef)(0);
  updateRef.current += 1;
  var isFieldChildren = ((_type = children.type) === null || _type === void 0 ? void 0 : _type[_constant.COMPONENT_TYPE_KEY]) === _Field.FIELD_KEY || customField;
  function renderLayout(baseChildren, fieldId, meta, isRequired) {
    if (noStyle) {
      return baseChildren;
    }
    return /*#__PURE__*/_react().default.createElement(FormItemLayout, {
      isFieldChildren: isFieldChildren,
      className: className,
      style: style,
      label: label,
      tooltip: tooltip,
      intro: intro,
      required: isRequired,
      disabled: disabled,
      htmlFor: fieldId,
      meta: meta,
      colon: colon,
      labelWidth: labelWidth,
      labelAlign: labelAlign,
      labelClass: labelClass,
      showValidateMessage: showValidateMessage,
      onClick: onClick
    }, baseChildren);
  }
  var isRenderProps = typeof children === 'function';
  if (!name && !isRenderProps && !props.dependencies) {
    return renderLayout(children);
  }
  return /*#__PURE__*/_react().default.createElement(_rcFieldForm().Field, (0, _extends2().default)({}, fieldProps, {
    name: name,
    shouldUpdate: shouldUpdate,
    dependencies: dependencies,
    rules: rules,
    trigger: trigger,
    validateTrigger: mergedValidateTrigger
  }), function (control, meta, context) {
    var childNode = null;
    var isRequired = required !== undefined ? required : !!(rules && rules.some(function (rule) {
      if (rule && (0, _typeof2().default)(rule) === 'object' && rule.required) {
        return true;
      }
      return false;
    }));
    var fieldId = ((0, _utils.toArray)(name).length && meta ? meta.name : []).join('_');
    if (shouldUpdate && dependencies) {
      devWarning('FormItem', "`shouldUpdate` and `dependencies` shouldn't be used together.");
    }
    if (isRenderProps) {
      if ((shouldUpdate || dependencies) && !name) {
        childNode = children(context);
      } else {
        if (!(shouldUpdate || dependencies)) {
          devWarning('FormItem', '`children` of render props only work with `shouldUpdate` or `dependencies`.');
        }
        if (name) {
          devWarning('FormItem', "Do not use `name` with `children` of render props since it's not a field.");
        }
      }
    } else if (dependencies && !name) {
      devWarning('FormItem', 'Must set `name` or use render props when `dependencies` is set.');
    } else if ( /*#__PURE__*/_react().default.isValidElement(children)) {
      var childProps = _objectSpread(_objectSpread({}, children.props), control);
      if (!childProps.id) {
        childProps.id = fieldId;
      }
      if (disabled) {
        childProps.disabled = disabled;
      }

      // We should keep user origin event handler
      var triggers = new Set([].concat((0, _toConsumableArray2().default)((0, _utils.toArray)(trigger)), (0, _toConsumableArray2().default)((0, _utils.toArray)(mergedValidateTrigger))));
      triggers.forEach(function (eventName) {
        childProps[eventName] = function () {
          var _control$eventName, _children$props$event, _children$props;
          for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
          }
          (_control$eventName = control[eventName]) === null || _control$eventName === void 0 ? void 0 : _control$eventName.call.apply(_control$eventName, [control].concat(args));
          (_children$props$event = (_children$props = children.props)[eventName]) === null || _children$props$event === void 0 ? void 0 : _children$props$event.call.apply(_children$props$event, [_children$props].concat(args));
        };
      });
      childNode = /*#__PURE__*/_react().default.createElement(MemoInput, {
        value: control[props.valuePropName || 'value'],
        update: updateRef.current
      }, /*#__PURE__*/_react().default.cloneElement(children, childProps));
      if (isFieldChildren) {
        childProps.value = childProps.value || '';
        childNode = /*#__PURE__*/_react().default.cloneElement(children, childProps);
      }
    } else {
      if (name) {
        devWarning('FormItem', '`name` is only used for validate React element. If you are using FormItem as layout display, please remove `name` instead.');
      }
      childNode = children;
    }
    return renderLayout(childNode, fieldId, meta, isRequired);
  });
};
var _default = FormItem;
exports.default = _default;