"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.useCountDown = useCountDown;
function _slicedToArray2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));
  _slicedToArray2 = function _slicedToArray2() {
    return data;
  };
  return data;
}
function _react() {
  var data = require("react");
  _react = function _react() {
    return data;
  };
  return data;
}
var _utils = require("../utils");
var _raf = require("../utils/raf");
var SECOND = 1000;
var MINUTE = 60 * SECOND;
var HOUR = 60 * MINUTE;
var DAY = 24 * HOUR;
function parseTime(time) {
  var days = Math.floor(time / DAY);
  var hours = Math.floor(time % DAY / HOUR);
  var minutes = Math.floor(time % HOUR / MINUTE);
  var seconds = Math.floor(time % MINUTE / SECOND);
  var milliseconds = Math.floor(time % SECOND);
  return {
    total: time,
    days: days,
    hours: hours,
    minutes: minutes,
    seconds: seconds,
    milliseconds: milliseconds
  };
}
function isSameSecond(time1, time2) {
  return Math.floor(time1 / 1000) === Math.floor(time2 / 1000);
}
function useCountDown(options) {
  var _useState = (0, _react().useState)(options.time),
    _useState2 = (0, _slicedToArray2().default)(_useState, 2),
    remain = _useState2[0],
    setRemain = _useState2[1];
  var remainRef = (0, _react().useRef)(remain);
  var rafId = (0, _react().useRef)();
  var endTime = (0, _react().useRef)();
  var counting = (0, _react().useRef)();
  var current = (0, _react().useMemo)(function () {
    return parseTime(remain);
  }, [remain]);
  var pause = function pause() {
    counting.current = false;
    (0, _raf.cancelRaf)(rafId.current);
  };
  var getCurrentRemain = function getCurrentRemain() {
    return Math.max(endTime.current - Date.now(), 0);
  };
  var handleRemain = function handleRemain(value) {
    var _options$onChange;
    setRemain(value);
    remainRef.current = value;
    (_options$onChange = options.onChange) === null || _options$onChange === void 0 ? void 0 : _options$onChange.call(options, parseTime(value));
    if (value === 0) {
      var _options$onFinish;
      pause();
      (_options$onFinish = options.onFinish) === null || _options$onFinish === void 0 ? void 0 : _options$onFinish.call(options);
    }
  };
  var microTick = function microTick() {
    rafId.current = (0, _raf.raf)(function () {
      // in case of call reset immediately after finish
      if (counting.current) {
        handleRemain(getCurrentRemain());
        if (remainRef.current > 0) {
          microTick();
        }
      }
    });
  };
  var macroTick = function macroTick() {
    rafId.current = (0, _raf.raf)(function () {
      // in case of call reset immediately after finish
      if (counting.current) {
        var remainRemain = getCurrentRemain();
        if (!isSameSecond(remainRemain, remainRef.current) || remainRemain === 0) {
          handleRemain(remainRemain);
        }
        if (remainRef.current > 0) {
          macroTick();
        }
      }
    });
  };
  var tick = function tick() {
    // should not start counting in server
    if (!_utils.inBrowser) {
      return;
    }
    if (options.millisecond) {
      microTick();
    } else {
      macroTick();
    }
  };
  var start = function start() {
    if (!counting.current) {
      endTime.current = Date.now() + remainRef.current;
      counting.current = true;
      tick();
    }
  };
  var reset = function reset() {
    var totalTime = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : options.time;
    pause();
    setRemain(totalTime);
    remainRef.current = totalTime;
  };
  (0, _react().useEffect)(function () {
    return function () {
      pause();
    };
  }, []);
  return {
    start: start,
    pause: pause,
    reset: reset,
    current: current
  };
}