"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
function _defineProperty2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
  _defineProperty2 = function _defineProperty2() {
    return data;
  };
  return data;
}
function _slicedToArray2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));
  _slicedToArray2 = function _slicedToArray2() {
    return data;
  };
  return data;
}
function _react() {
  var data = _interopRequireWildcard(require("react"));
  _react = function _react() {
    return data;
  };
  return data;
}
function _classnames2() {
  var data = _interopRequireDefault(require("classnames"));
  _classnames2 = function _classnames2() {
    return data;
  };
  return data;
}
var _icon = _interopRequireDefault(require("../icon"));
var _utils = require("../utils");
var _constant = require("../utils/constant");
var _useHeight = _interopRequireDefault(require("../hooks/use-height"));
var _ConfigProviderContext = _interopRequireDefault(require("../config-provider/ConfigProviderContext"));
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
var NavBar = function NavBar(props) {
  var _useContext = (0, _react().useContext)(_ConfigProviderContext.default),
    prefixCls = _useContext.prefixCls,
    createNamespace = _useContext.createNamespace;
  var _createNamespace = createNamespace('nav-bar', prefixCls),
    _createNamespace2 = (0, _slicedToArray2().default)(_createNamespace, 1),
    bem = _createNamespace2[0];
  var navBarRef = (0, _react().useRef)();
  var height = (0, _useHeight.default)(navBarRef);
  var onClickLeft = function onClickLeft(event) {
    var _props$onClickLeft;
    return (_props$onClickLeft = props.onClickLeft) === null || _props$onClickLeft === void 0 ? void 0 : _props$onClickLeft.call(props, event);
  };
  var onClickRight = function onClickRight(event) {
    var _props$onClickRight;
    return (_props$onClickRight = props.onClickRight) === null || _props$onClickRight === void 0 ? void 0 : _props$onClickRight.call(props, event);
  };
  var renderLeft = function renderLeft() {
    return [props.leftArrow && /*#__PURE__*/_react().default.createElement(_icon.default, {
      key: "icon",
      className: (0, _classnames2().default)(bem('arrow')),
      name: "arrow-left"
    }), props.leftArea && /*#__PURE__*/_react().default.createElement("span", {
      key: "left-area",
      className: (0, _classnames2().default)(bem('text'))
    }, props.leftArea)];
  };
  var renderRight = function renderRight() {
    return /*#__PURE__*/_react().default.createElement("span", {
      className: (0, _classnames2().default)(bem('text'))
    }, props.rightArea);
  };
  var renderNavBar = function renderNavBar() {
    var title = props.title,
      fixed = props.fixed,
      border = props.border,
      zIndex = props.zIndex;
    var style = (0, _utils.getZIndexStyle)(zIndex);
    var hasLeft = props.leftArrow || props.leftArea;
    var hasRight = props.rightArea;
    return /*#__PURE__*/_react().default.createElement("div", {
      ref: navBarRef,
      style: style,
      className: (0, _classnames2().default)(bem({
        fixed: fixed,
        'safe-area-inset-top': props.safeAreaInsetTop
      }), (0, _defineProperty2().default)({}, _constant.BORDER_BOTTOM, border))
    }, /*#__PURE__*/_react().default.createElement("div", {
      className: (0, _classnames2().default)(bem('content'))
    }, hasLeft && /*#__PURE__*/_react().default.createElement("div", {
      className: (0, _classnames2().default)(bem('left'), _constant.HAPTICS_FEEDBACK),
      onClick: onClickLeft
    }, renderLeft()), /*#__PURE__*/_react().default.createElement("div", {
      className: (0, _classnames2().default)(bem('title'), 'van-ellipsis')
    }, title), hasRight && /*#__PURE__*/_react().default.createElement("div", {
      className: (0, _classnames2().default)(bem('right'), _constant.HAPTICS_FEEDBACK),
      onClick: onClickRight
    }, renderRight())));
  };
  var renderPlaceholder = function renderPlaceholder() {
    return /*#__PURE__*/_react().default.createElement("div", {
      className: (0, _classnames2().default)(bem('placeholder')),
      style: {
        height: height ? "".concat(height, "px") : undefined
      }
    }, renderNavBar());
  };
  if (props.fixed && props.placeholder) {
    return renderPlaceholder();
  }
  return renderNavBar();
};
NavBar.defaultProps = {
  title: '',
  leftArea: '',
  rightArea: '',
  leftArrow: false,
  border: true,
  fixed: false,
  placeholder: false,
  zIndex: 1,
  safeAreaInsetTop: false
};
var _default = NavBar;
exports.default = _default;