"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
function _slicedToArray2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));
  _slicedToArray2 = function _slicedToArray2() {
    return data;
  };
  return data;
}
function _react() {
  var data = _interopRequireWildcard(require("react"));
  _react = function _react() {
    return data;
  };
  return data;
}
function _classnames() {
  var data = _interopRequireDefault(require("classnames"));
  _classnames = function _classnames() {
    return data;
  };
  return data;
}
var _loading = _interopRequireDefault(require("../loading"));
var _useTouch = require("../hooks/use-touch");
var _ConfigProviderContext = _interopRequireDefault(require("../config-provider/ConfigProviderContext"));
var _utils = require("../utils");
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
var NumberKeyboardKey = function NumberKeyboardKey(props) {
  var type = props.type,
    text = props.text,
    color = props.color,
    wider = props.wider,
    large = props.large,
    loading = props.loading,
    onPress = props.onPress,
    children = props.children;
  var _useContext = (0, _react().useContext)(_ConfigProviderContext.default),
    prefixCls = _useContext.prefixCls,
    createNamespace = _useContext.createNamespace;
  var _createNamespace = createNamespace('key', prefixCls),
    _createNamespace2 = (0, _slicedToArray2().default)(_createNamespace, 1),
    bem = _createNamespace2[0];
  var touch = (0, _useTouch.useTouch)();
  var _useState = (0, _react().useState)(false),
    _useState2 = (0, _slicedToArray2().default)(_useState, 2),
    active = _useState2[0],
    setActive = _useState2[1];
  var CollapseIcon = /*#__PURE__*/_react().default.createElement("svg", {
    className: (0, _classnames().default)(bem('collapse-icon')),
    viewBox: "0 0 30 24"
  }, /*#__PURE__*/_react().default.createElement("path", {
    d: "M26 13h-2v2h2v-2zm-8-3h2V8h-2v2zm2-4h2V4h-2v2zm2 4h4V4h-2v4h-2v2zm-7 14 3-3h-6l3 3zM6 13H4v2h2v-2zm16 0H8v2h14v-2zm-12-3h2V8h-2v2zM28 0l1 1 1 1v15l-1 2H1l-1-2V2l1-1 1-1zm0 2H2v15h26V2zM6 4v2H4V4zm10 2h2V4h-2v2zM8 9v1H4V8zm8 0v1h-2V8zm-6-5v2H8V4zm4 0v2h-2V4z",
    fill: "currentColor"
  }));
  var DeleteIcon = /*#__PURE__*/_react().default.createElement("svg", {
    className: (0, _classnames().default)(bem('delete-icon')),
    viewBox: "0 0 32 22"
  }, /*#__PURE__*/_react().default.createElement("path", {
    d: "M28 0a4 4 0 0 1 4 4v14a4 4 0 0 1-4 4H10.4a2 2 0 0 1-1.4-.6L1 13.1c-.6-.5-.9-1.3-.9-2 0-1 .3-1.7.9-2.2L9 .6a2 2 0 0 1 1.4-.6zm0 2H10.4l-8.2 8.3a1 1 0 0 0-.3.7c0 .3.1.5.3.7l8.2 8.4H28a2 2 0 0 0 2-2V4c0-1.1-.9-2-2-2zm-5 4a1 1 0 0 1 .7.3 1 1 0 0 1 0 1.4L20.4 11l3.3 3.3c.2.2.3.5.3.7 0 .3-.1.5-.3.7a1 1 0 0 1-.7.3 1 1 0 0 1-.7-.3L19 12.4l-3.4 3.3a1 1 0 0 1-.6.3 1 1 0 0 1-.7-.3 1 1 0 0 1-.3-.7c0-.2.1-.5.3-.7l3.3-3.3-3.3-3.3A1 1 0 0 1 14 7c0-.3.1-.5.3-.7A1 1 0 0 1 15 6a1 1 0 0 1 .6.3L19 9.6l3.3-3.3A1 1 0 0 1 23 6z",
    fill: "currentColor"
  }));
  var onTouchStart = function onTouchStart(event) {
    touch.start(event);
    setActive(true);
  };
  var onTouchMove = function onTouchMove(event) {
    touch.move(event);
    if (touch.direction.current) {
      setActive(false);
    }
  };
  var onTouchEnd = function onTouchEnd(event) {
    if (active) {
      // eliminate tap delay on safari
      if (!children) {
        (0, _utils.preventDefault)(event);
      }
      setActive(false);
      onPress(String(text), type);
    }
  };
  var renderContent = function renderContent() {
    if (loading) {
      return /*#__PURE__*/_react().default.createElement(_loading.default, {
        className: (0, _classnames().default)(bem('loading-icon'))
      });
    }
    var contentText = children || text;
    switch (type) {
      case 'delete':
        return contentText || DeleteIcon;
      case 'extra':
        return contentText || CollapseIcon;
      default:
        return contentText;
    }
  };
  return /*#__PURE__*/_react().default.createElement("div", {
    className: (0, _classnames().default)(bem('wrapper', {
      wider: wider
    })),
    onTouchStart: onTouchStart,
    onTouchMove: onTouchMove,
    onTouchEnd: onTouchEnd,
    onTouchCancel: onTouchEnd
  }, /*#__PURE__*/_react().default.createElement("div", {
    role: "button",
    tabIndex: 0,
    className: (0, _classnames().default)(bem([color, {
      large: large,
      active: active,
      delete: type === 'delete'
    }]))
  }, renderContent()));
};
NumberKeyboardKey.defaultProps = {
  color: '',
  wider: false,
  large: false,
  loading: false
};
var _default = NumberKeyboardKey;
exports.default = _default;