"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
function _extends2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/extends"));
  _extends2 = function _extends2() {
    return data;
  };
  return data;
}
function _slicedToArray2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));
  _slicedToArray2 = function _slicedToArray2() {
    return data;
  };
  return data;
}
function _react() {
  var data = _interopRequireWildcard(require("react"));
  _react = function _react() {
    return data;
  };
  return data;
}
function _classnames() {
  var data = _interopRequireDefault(require("classnames"));
  _classnames = function _classnames() {
    return data;
  };
  return data;
}
function _popperjs() {
  var data = require("@vant/popperjs");
  _popperjs = function _popperjs() {
    return data;
  };
  return data;
}
var _popup = _interopRequireDefault(require("../popup"));
var _icon = _interopRequireDefault(require("../icon"));
var _utils = require("../utils");
var _constant = require("../utils/constant");
var _useClickAway = _interopRequireDefault(require("../hooks/use-click-away"));
var _ConfigProviderContext = _interopRequireDefault(require("../config-provider/ConfigProviderContext"));
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
// component

// utils

// hook

var popupProps = ['overlay', 'duration', 'overlayStyle', 'overlayClass', 'closeOnClickOverlay', 'teleport', 'onClose', 'onOpen', 'onClosed', 'onOpened', 'onClickOverlay'];
var Popover = /*#__PURE__*/(0, _react().forwardRef)(function (props, ref) {
  var _useContext = (0, _react().useContext)(_ConfigProviderContext.default),
    prefixCls = _useContext.prefixCls,
    createNamespace = _useContext.createNamespace;
  var _createNamespace = createNamespace('popover', prefixCls),
    _createNamespace2 = (0, _slicedToArray2().default)(_createNamespace, 1),
    bem = _createNamespace2[0];
  var _useState = (0, _react().useState)(false),
    _useState2 = (0, _slicedToArray2().default)(_useState, 2),
    visible = _useState2[0],
    updateShow = _useState2[1];
  var popper = (0, _react().useRef)(null);
  var wrapperRef = (0, _react().useRef)();
  var popoverRef = (0, _react().useRef)();
  var createPopperInstance = function createPopperInstance() {
    return (0, _popperjs().createPopper)(wrapperRef.current, popoverRef.current.popupRef.current, {
      placement: props.placement,
      modifiers: [{
        name: 'computeStyles',
        options: {
          adaptive: false,
          gpuAcceleration: false
        }
      }, (0, _utils.extend)({}, _popperjs().offsetModifier, {
        options: {
          offset: props.offset
        }
      })]
    });
  };
  var onClickWrapper = function onClickWrapper() {
    if (props.trigger === 'click') {
      updateShow(!visible);
    }
  };
  var onClickAction = function onClickAction(action, index) {
    var _props$onSelect;
    if (action.disabled) {
      return;
    }
    (_props$onSelect = props.onSelect) === null || _props$onSelect === void 0 ? void 0 : _props$onSelect.call(props, action, index);
    if (props.closeOnClickAction) {
      updateShow(false);
    }
  };
  var onClickAway = function onClickAway() {
    if (!props.overlay || props.closeOnClickOverlay) {
      updateShow(false);
    }
  };
  var renderAction = function renderAction(action, index) {
    var icon = action.icon,
      text = action.text,
      color = action.color,
      disabled = action.disabled,
      actionClassname = action.className;
    return /*#__PURE__*/_react().default.createElement("div", {
      // role="menuitem"
      key: index,
      className: (0, _classnames().default)(bem('action', {
        disabled: disabled,
        'with-icon': icon
      }), actionClassname),
      style: {
        color: color
      },
      tabIndex: disabled ? undefined : 0,
      "aria-disabled": disabled || undefined,
      onClick: function onClick() {
        return onClickAction(action, index);
      }
    }, icon && /*#__PURE__*/_react().default.createElement(_icon.default, {
      name: icon,
      classPrefix: props.iconPrefix,
      className: (0, _classnames().default)(bem('action-icon'))
    }), /*#__PURE__*/_react().default.createElement("div", {
      className: (0, _classnames().default)(bem('action-text'), _constant.BORDER_BOTTOM)
    }, text));
  };
  (0, _react().useEffect)(function () {
    return function () {
      if (popper.current) {
        var _popper$current;
        (_popper$current = popper.current) === null || _popper$current === void 0 ? void 0 : _popper$current.destroy();
        popper.current = null;
      }
    };
  }, []);
  (0, _react().useEffect)(function () {
    var updateLocation = function updateLocation() {
      if (!visible) {
        return;
      }
      if (!popper.current) {
        popper.current = createPopperInstance();
      } else {
        var _popper$current2;
        (_popper$current2 = popper.current) === null || _popper$current2 === void 0 ? void 0 : _popper$current2.setOptions({
          placement: props.placement
        });
      }
    };
    updateLocation();
  }, [visible, props.placement]);
  (0, _react().useEffect)(function () {
    var popupTarget;
    var prevent = function prevent(e) {
      return e.stopPropagation();
    };
    if (popoverRef.current && popoverRef.current.popupRef.current) {
      popupTarget = popoverRef.current.popupRef.current;
      popupTarget.addEventListener('touchstart', prevent);
    }
    return function () {
      if (popupTarget) popupTarget.removeEventListener('touchstart', prevent);
    };
  }, [popoverRef.current]);
  (0, _react().useImperativeHandle)(ref, function () {
    return {
      show: function show() {
        if (visible) {
          updateShow(false);
          setTimeout(function () {
            return updateShow(true);
          }, 0);
          return;
        }
        updateShow(true);
      },
      hide: function hide() {
        return updateShow(false);
      }
    };
  });
  (0, _useClickAway.default)(wrapperRef, onClickAway, 'touchstart', props.closeOnClickOutside);
  return /*#__PURE__*/_react().default.createElement(_react().default.Fragment, null, /*#__PURE__*/_react().default.createElement("span", {
    ref: wrapperRef,
    className: (0, _classnames().default)(bem('wrapper')),
    onClick: onClickWrapper
  }, props.reference), /*#__PURE__*/_react().default.createElement(_popup.default, (0, _extends2().default)({
    ref: popoverRef,
    visible: visible,
    className: (0, _classnames().default)(bem([props.theme])),
    position: "",
    transition: "rc-zoom",
    lockScroll: false
  }, (0, _utils.pick)(props, popupProps)), /*#__PURE__*/_react().default.createElement("div", {
    className: (0, _classnames().default)(bem('arrow'))
  }), /*#__PURE__*/_react().default.createElement("div", {
    role: "menu",
    className: (0, _classnames().default)(bem('content'))
  }, props.children || props.actions.map(renderAction))));
});
Popover.defaultProps = {
  overlay: false,
  duration: 300,
  closeOnClickAction: true,
  closeOnClickOverlay: true,
  closeOnClickOutside: true,
  offset: [0, 8],
  theme: 'light',
  trigger: 'click',
  actions: [],
  placement: 'bottom'
};
Popover.displayName = 'Popover';
var _default = Popover;
exports.default = _default;