"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
function _slicedToArray2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));
  _slicedToArray2 = function _slicedToArray2() {
    return data;
  };
  return data;
}
function _react() {
  var data = _interopRequireWildcard(require("react"));
  _react = function _react() {
    return data;
  };
  return data;
}
function _classnames() {
  var data = _interopRequireDefault(require("classnames"));
  _classnames = function _classnames() {
    return data;
  };
  return data;
}
var _utils = require("../utils");
var _ConfigProviderContext = _interopRequireDefault(require("../config-provider/ConfigProviderContext"));
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
var Progress = function Progress(props) {
  var _useContext = (0, _react().useContext)(_ConfigProviderContext.default),
    prefixCls = _useContext.prefixCls,
    createNamespace = _useContext.createNamespace;
  var _createNamespace = createNamespace('progress', prefixCls),
    _createNamespace2 = (0, _slicedToArray2().default)(_createNamespace, 1),
    bem = _createNamespace2[0];
  var inactive = props.inactive,
    color = props.color,
    trackColor = props.trackColor,
    percentage = props.percentage,
    strokeWidth = props.strokeWidth;
  var background = (0, _react().useMemo)(function () {
    return inactive ? undefined : color;
  }, [inactive, color]);
  var renderPivot = function renderPivot() {
    var textColor = props.textColor,
      pivotText = props.pivotText,
      pivotColor = props.pivotColor;
    var text = pivotText !== null && pivotText !== void 0 ? pivotText : "".concat(percentage, "%");
    if (props.showPivot && text) {
      var style = {
        color: textColor,
        left: "".concat(+percentage, "%"),
        transform: "translate(-".concat(+percentage, "%,-50%)"),
        background: pivotColor || background
      };
      return /*#__PURE__*/_react().default.createElement("span", {
        style: style,
        className: bem('pivot', {
          inactive: props.inactive
        })
      }, text);
    }
    return null;
  };
  var rootStyle = {
    background: trackColor,
    height: (0, _utils.addUnit)(strokeWidth)
  };
  var portionStyle = {
    width: "".concat(percentage, "%"),
    background: background
  };
  return /*#__PURE__*/_react().default.createElement("div", {
    className: (0, _classnames().default)(props.className, bem()),
    style: rootStyle
  }, /*#__PURE__*/_react().default.createElement("span", {
    className: (0, _classnames().default)(bem('portion', {
      inactive: props.inactive
    })),
    style: portionStyle
  }), renderPivot());
};
Progress.defaultProps = {
  percentage: 0,
  strokeWidth: '4px',
  color: '#1989fa',
  trackColor: '#e5e5e5',
  pivotColor: '',
  textColor: 'white',
  inactive: false,
  showPivot: true
};
var _default = Progress;
exports.default = _default;