"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
function _extends2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/extends"));
  _extends2 = function _extends2() {
    return data;
  };
  return data;
}
function _slicedToArray2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));
  _slicedToArray2 = function _slicedToArray2() {
    return data;
  };
  return data;
}
function _react() {
  var data = _interopRequireWildcard(require("react"));
  _react = function _react() {
    return data;
  };
  return data;
}
function _classnames() {
  var data = _interopRequireDefault(require("classnames"));
  _classnames = function _classnames() {
    return data;
  };
  return data;
}
function _web() {
  var data = require("@react-spring/web");
  _web = function _web() {
    return data;
  };
  return data;
}
function _react2() {
  var data = require("@use-gesture/react");
  _react2 = function _react2() {
    return data;
  };
  return data;
}
var _useClickAway = _interopRequireDefault(require("../hooks/use-click-away"));
var _useMountedRef = _interopRequireDefault(require("../hooks/use-mounted-ref"));
var _ConfigProviderContext = _interopRequireDefault(require("../config-provider/ConfigProviderContext"));
var _interceptor = require("../utils/interceptor");
var _nearest = require("../utils/nearest");
var _utils = require("../utils");
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
/* eslint-disable @typescript-eslint/no-shadow */

var SwipeCell = /*#__PURE__*/(0, _react().forwardRef)(function (props, ref) {
  var _useContext = (0, _react().useContext)(_ConfigProviderContext.default),
    prefixCls = _useContext.prefixCls,
    createNamespace = _useContext.createNamespace;
  var _createNamespace = createNamespace('swipe-cell', prefixCls),
    _createNamespace2 = (0, _slicedToArray2().default)(_createNamespace, 1),
    bem = _createNamespace2[0];
  var rootRef = (0, _react().useRef)(null);
  var leftRef = (0, _react().useRef)();
  var rightRef = (0, _react().useRef)();
  var opened = (0, _react().useRef)(false);
  var lockClick = (0, _react().useRef)(false);
  var draggingRef = (0, _react().useRef)(false);
  var mountedRef = (0, _useMountedRef.default)();
  var getWidth = function getWidth(elementRef) {
    return elementRef.current ? elementRef.current.offsetWidth : 0;
  };
  function getLeftWidth() {
    return (0, _utils.isDef)(props.leftWidth) ? +props.leftWidth : getWidth(leftRef);
  }
  function getRightWidth() {
    return (0, _utils.isDef)(props.rightWidth) ? +props.rightWidth : getWidth(rightRef);
  }
  var _useSpring = (0, _web().useSpring)(function () {
      return {
        x: 0,
        config: {
          tension: 200,
          friction: 30
        }
      };
    }, []),
    _useSpring2 = (0, _slicedToArray2().default)(_useSpring, 2),
    x = _useSpring2[0].x,
    api = _useSpring2[1];
  var bind = (0, _react2().useDrag)(function (state) {
    if (!props.disabled) {
      lockClick.current = true;
      draggingRef.current = true;
      var _state$offset = (0, _slicedToArray2().default)(state.offset, 1),
        offsetX = _state$offset[0];
      if (state.last) {
        var leftWidth = getLeftWidth();
        var rightWidth = getRightWidth();
        var position = offsetX + state.velocity[0] * state.direction[0] * 50;
        if (offsetX > 0) {
          position = Math.max(0, position);
        } else {
          position = Math.min(0, position);
        }
        var nearestPosition = (0, _nearest.nearest)([-rightWidth, 0, leftWidth], position);
        api.start({
          x: nearestPosition
        });
        opened.current = nearestPosition !== 0;
        window.setTimeout(function () {
          if (mountedRef.current) {
            draggingRef.current = false;
            lockClick.current = false;
          }
        });
      } else {
        api.start({
          x: offsetX,
          immediate: true
        });
      }
    }
  }, {
    from: function from() {
      return [x.get(), 0];
    },
    bounds: function bounds() {
      var leftWidth = getLeftWidth();
      var rightWidth = getRightWidth();
      return {
        left: -rightWidth,
        right: leftWidth
      };
    },
    axis: 'x',
    preventScroll: true,
    pointer: {
      touch: true
    }
  });
  var _open = function open(side) {
    var _props$onOpen;
    opened.current = true;
    var offset = side === 'left' ? getLeftWidth() : -getRightWidth();
    api.start({
      x: offset
    });
    (_props$onOpen = props.onOpen) === null || _props$onOpen === void 0 ? void 0 : _props$onOpen.call(props, {
      position: side,
      name: props.name
    });
  };
  var _close = function close(position) {
    api.start({
      x: 0
    });
    if (opened.current) {
      var _props$onClose;
      opened.current = false;
      (_props$onClose = props.onClose) === null || _props$onClose === void 0 ? void 0 : _props$onClose.call(props, {
        position: position,
        name: props.name
      });
    }
  };
  var onClick = function onClick() {
    var _props$onClick;
    var position = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 'outside';
    (_props$onClick = props.onClick) === null || _props$onClick === void 0 ? void 0 : _props$onClick.call(props, position);
    if (opened.current && !lockClick.current) {
      (0, _interceptor.callInterceptor)({
        interceptor: props.beforeClose,
        args: [{
          name: props.name,
          position: position,
          instance: {
            close: function close() {
              return _close(position);
            }
          }
        }],
        done: function done() {
          return _close(position);
        }
      });
    }
  };
  var getClickHandler = function getClickHandler(position, stop) {
    return function (event) {
      if (stop) {
        event.preventDefault();
        event.stopPropagation();
      }
      onClick(position);
    };
  };
  var renderSideContent = function renderSideContent(side, sideRef) {
    var contentSlot = props[side];
    return contentSlot ? /*#__PURE__*/_react().default.createElement("div", {
      ref: sideRef,
      className: (0, _classnames().default)(bem(side)),
      onClick: getClickHandler(side, true)
    }, contentSlot) : null;
  };
  (0, _react().useImperativeHandle)(ref, function () {
    return {
      open: function open(side) {
        return _open(side);
      },
      close: _close
    };
  });
  (0, _useClickAway.default)(rootRef, function () {
    return onClick('outside');
  }, 'touchstart', props.hideOnClickOutside);
  return /*#__PURE__*/_react().default.createElement("div", (0, _extends2().default)({
    ref: rootRef
  }, bind(), {
    className: (0, _classnames().default)(bem()),
    onClickCapture: function onClickCapture(e) {
      if (draggingRef.current) {
        e.stopPropagation();
        e.preventDefault();
      }
    },
    onClick: getClickHandler('cell')
  }), /*#__PURE__*/_react().default.createElement(_web().animated.div, {
    className: (0, _classnames().default)(bem('wrapper')),
    style: {
      x: x
    }
  }, renderSideContent('left', leftRef), /*#__PURE__*/_react().default.createElement("div", {
    className: (0, _classnames().default)(bem('content')),
    onClickCapture: function onClickCapture(e) {
      if (x.goal !== 0) {
        e.preventDefault();
        e.stopPropagation();
        api.start({
          x: 0
        });
      }
    }
  }, /*#__PURE__*/_react().default.createElement(_web().animated.div, {
    style: {
      pointerEvents: x.to(function (v) {
        return v !== 0 && x.goal !== 0 ? 'none' : 'unset';
      })
    }
  }, props.children)), renderSideContent('right', rightRef)));
});
SwipeCell.defaultProps = {
  disabled: false,
  hideOnClickOutside: true
};
var _default = SwipeCell;
exports.default = _default;