"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
function _extends2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/extends"));
  _extends2 = function _extends2() {
    return data;
  };
  return data;
}
function _slicedToArray2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));
  _slicedToArray2 = function _slicedToArray2() {
    return data;
  };
  return data;
}
function _defineProperty2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
  _defineProperty2 = function _defineProperty2() {
    return data;
  };
  return data;
}
function _react() {
  var data = _interopRequireWildcard(require("react"));
  _react = function _react() {
    return data;
  };
  return data;
}
function _reactDom() {
  var data = _interopRequireDefault(require("react-dom"));
  _reactDom = function _reactDom() {
    return data;
  };
  return data;
}
var _utils = require("../utils");
var _getContainer = require("../utils/dom/getContainer");
var _lockClick = require("./lock-click");
var _Toast = _interopRequireDefault(require("./Toast"));
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2().default)(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
var defaultOptions = {
  icon: '',
  message: '',
  className: '',
  type: 'info',
  position: 'middle',
  forbidClick: false,
  duration: 2000,
  teleport: function teleport() {
    return document.body;
  }
};
var toastQueue = [];
var allowMultiple = false;
var currentOptions = (0, _utils.extend)({}, defaultOptions);
// default options of specific type
var defaultOptionsMap = new Map();
function parseOptions(message) {
  if ((0, _utils.isObject)(message)) {
    return message;
  }
  return {
    message: message
  };
}
var syncClear = function syncClear() {
  var fn = toastQueue.pop();
  while (fn) {
    fn();
    fn = toastQueue.pop();
  }
};

// 针对 toast 还没弹出来就立刻销毁的情况，将销毁放到下一个 event loop 中，避免销毁失败。
var nextTickClear = function nextTickClear() {
  setTimeout(syncClear);
};
var Toast = function Toast(toastProps) {
  var props = parseOptions(toastProps);
  var instance = {
    config: function config() {},
    clear: function clear() {
      return null;
    }
  };
  var timer = 0;
  // const { onClose, teleport } = props;
  var container = document.createElement('div');
  container.className = 'toast-contanier';
  var bodyContainer = (0, _getContainer.resolveContainer)(props.teleport);
  bodyContainer.appendChild(container);
  var TempToast = function TempToast() {
    var options = _objectSpread({
      duration: 2000
    }, props);
    var _useState = (0, _react().useState)(false),
      _useState2 = (0, _slicedToArray2().default)(_useState, 2),
      visible = _useState2[0],
      setVisible = _useState2[1];
    var _useState3 = (0, _react().useState)(_objectSpread({}, options)),
      _useState4 = (0, _slicedToArray2().default)(_useState3, 2),
      state = _useState4[0],
      setState = _useState4[1];
    var unmountComponent = (0, _react().useCallback)(function () {
      if (state.forbidClick) {
        (0, _lockClick.lockClick)(false);
      }
      var unmountResult = _reactDom().default.unmountComponentAtNode(container);
      if (unmountResult && container.parentNode) {
        container.parentNode.removeChild(container);
      }
    }, [container]);
    var handleClose = (0, _react().useCallback)(function () {
      var _props$onClose;
      setVisible(false);
      (_props$onClose = props.onClose) === null || _props$onClose === void 0 ? void 0 : _props$onClose.call(props);
    }, []);
    instance.clear = unmountComponent;
    instance.config = (0, _react().useCallback)(function (nextState) {
      setState(function (prev) {
        return typeof nextState === 'function' ? _objectSpread(_objectSpread({}, prev), nextState(prev)) : _objectSpread(_objectSpread({}, prev), nextState);
      });
    }, [setState]);
    (0, _react().useEffect)(function () {
      setVisible(true);
      if (!allowMultiple) syncClear();
      toastQueue.push(unmountComponent);
      if (state.duration !== 0 && 'duration' in state) {
        timer = window.setTimeout(handleClose, +state.duration);
      }
      return function () {
        if (timer !== 0) {
          window.clearTimeout(timer);
        }
      };
    }, []);
    return /*#__PURE__*/_react().default.createElement(_Toast.default, (0, _extends2().default)({}, state, {
      visible: visible,
      teleport: function teleport() {
        return container;
      },
      onClose: handleClose,
      onClosed: unmountComponent
    }));
  };
  _reactDom().default.render( /*#__PURE__*/_react().default.createElement(TempToast, null), container);
  return instance;
};
var createMethod = function createMethod(type) {
  return function (options) {
    Toast((0, _utils.extend)({}, currentOptions, defaultOptionsMap.get(type), parseOptions(options), {
      type: type
    }));
  };
};
['info', 'loading', 'success', 'fail'].forEach(function (method) {
  Toast[method] = createMethod(method);
});
Toast.allowMultiple = function () {
  var value = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : true;
  allowMultiple = value;
};
Toast.clear = nextTickClear;
var setDefaultOptions = function setDefaultOptions(type, options) {
  if (typeof type === 'string') {
    defaultOptionsMap.set(type, options);
  } else {
    (0, _utils.extend)(currentOptions, type);
  }
};
Toast.setDefaultOptions = setDefaultOptions;
Toast.resetDefaultOptions = function (type) {
  if (typeof type === 'string') {
    defaultOptionsMap.delete(type);
  } else {
    currentOptions = (0, _utils.extend)({}, defaultOptions);
    defaultOptionsMap.clear();
  }
};
var _default = Toast;
exports.default = _default;